@echo off

rem *******************************************************
rem * %1 = font name
rem * %2 = magnification step
rem * %3 = x-dpi
rem * %4 = y-dpi
rem * %5 = x-base-dpi
rem * %6 = y-base-dpi
rem * %7 = "dvips" if from dvips, else empty
rem *******************************************************

set PK_MAG=%2
set PK_DEV=

if %5==%6 goto SQUARE_PIXELS

if %5==120      goto X120
if %5==160      goto X160
if %5==240      goto X240
if %5==360      goto X360
goto UNKNOWN

:X120
if %6==216      goto EPSONMX
goto UNKNOWN

:X160
if %6==144      goto ITOH
goto UNKNOWN

:X240
if %6==216      goto EPSONFX
goto UNKNOWN

:X360
if %6==180      goto LQMEDRES
goto UNKNOWN

rem 120x216 (PK_DEV=epsonmx if used emTeX's local.mf)
:EPSONMX
set PK_DEV=epsonlo
set PK_SUB_BASE=pixel.mx
goto DO_IT

rem 160x144 (can be used with emTeX's local.mf)
:ITOH
set PK_DEV=itoh
set PK_SUB_BASE=pixel.ito
goto DO_IT

rem 240x216 (can be used with emTeX's local.mf)
:EPSONFX
set PK_DEV=epsonfx
set PK_SUB_BASE=pixel.fx
goto DO_IT

rem 360x180 (can be used with emTeX's local.mf)
:LQMEDRES
set PK_DEV=lqmedres
set PK_SUB_BASE=pixel.p6m
goto DO_IT

:SQUARE_PIXELS
if %5==180      goto LQLORES
if %5==300      goto HPLASER
if %5==360      goto LQHIRES
if %5==400      goto NEXTHI
if %5==600      goto LJIV
goto UNKNOWN

rem 180x180 (can be used with emTeX's local.mf)
:LQLORES
set PK_DEV=lqlores
set PK_SUB_BASE=pixel.p6l
goto DO_IT

rem 300x300 (can be used with emTeX's local.mf)
:HPLASER
set PK_DEV=hplaser
set PK_SUB_BASE=hplaser
goto DO_IT

rem 360x360 (can be used with emTeX's local.mf)
:LQHIRES
set PK_DEV=lqhires
set PK_SUB_BASE=pixel.p6h
goto DO_IT

rem 400x400 (can be used with emTeX's local.mf)
:NEXTHI
set PK_DEV=nexthi
set PK_SUB_BASE=pixel.nxt
goto DO_IT

rem 600x600 (can be used with emTeX's local.mf)
:LJIV
set PK_DEV=ljfour
set PK_SUB_BASE=pixel.jvi
goto DO_IT

rem *******************************************************

:DO_IT

rem set MF=virmf &plain
set MF=mf

set PK_BASE=c:\tex\pk
set PK_DIR=%PK_BASE%\%PK_SUB_BASE%\%3x%4
if %5==%6 set PK_DIR=%PK_BASE%\%PK_SUB_BASE%\%3

set TFM_BASE=c:\tex
set TFM_DIR=%TFM_BASE%\tfm

:: Windows for Workgroup 3.11 DOS box bug:
::    \<path>\null exists even if <path> does not exist.
:: (This is not true in the true DOS.)
:: So we cannot test existence of directories in
:: Windows for Wordgroup 3.11 DOS box...
:: if not exist %PK_BASE%\nul md %PK_BASE%
:: if not exist %PK_BASE%\%PK_SUB_BASE%\nul md %PK_BASE%\%PK_SUB_BASE%
:: if not exist %PK_DIR%\nul md %PK_DIR%
:: if not exist %TFM_BASE%\nul md %TFM_BASE
:: if not exist %TFM_DIR%\nul md %TFM_DIR%
md %PK_BASE%
md %PK_BASE%\%PK_SUB_BASE%
md %PK_DIR%
md %TFM_BASE
md %TFM_DIR%

if %7==dvips goto DVIPS
if %7==DVIPS goto DVIPS

echo on
%MF% \scrollmode;mode:=%PK_DEV%;mag:=magstep(%PK_MAG%);input %1
@echo off
if errorlevel 1 goto ERROR_EXIT
goto CONTINUE

:DVIPS
echo on
%MF% \scrollmode;mode:=%PK_DEV%;mag:=%PK_MAG%;input %1
@echo off
if errorlevel 1 goto ERROR_EXIT

:CONTINUE
echo on
gftopk ./%1.%3gf  %PK_DIR%\%1.pk
copy %1.tfm %TFM_DIR% > nul
@echo off

del %1.%3gf > nul
del %1.log > nul
del %1.tfm > nul

goto GETOUT

:UNKNOWN
echo I don't know the metafont mode for this device. Please
echo add this information to the file %0

:ERROR_EXIT
pause

:GETOUT


